package webspin.projects.sandbox.client;

import webspin.projects.sandbox.client.events.TableRowEvent;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.HasValue;

class AddRowPresenter {
	AddRowWidgetInterface widget;
	HandlerManager eventBus;
	
	/**
	 * Constructor
	 * @param widget
	 * @param eventBus
	 */
	public AddRowPresenter(AddRowWidgetInterface widget, HandlerManager eventBus)
	{
		this.eventBus = eventBus;
		this.bindWidget(widget);
	}
	
	/**
	 * bind the widget to the presenter and the eventbus
	 * @param widget
	 */
	public void bindWidget(AddRowWidgetInterface widget)
	{
		this.widget = widget;
		widget.getSendButton().addClickHandler(new ClickHandler(){
			public void onClick(ClickEvent event) {
				sendAddRowEvent();
			}
		});
	}

	/**
	 * the presenter does the sending!
	 */
	protected void sendAddRowEvent() {
		TableRowEvent event = new TableRowEvent();
		event.setRowName(widget.getTextBox().getValue());
		eventBus.fireEvent(event);
	}
	
	/**
	 * The interface all bound widgets should implements
	 * @author mabogie
	 *
	 */
	interface AddRowWidgetInterface {
		HasClickHandlers getSendButton();
		HasValue<String> getTextBox();
	}
}
