package webspin.projects.sandbox.client;



import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.RootPanel;


/**
 * The class is nothing more than a button sending an event, and a table adding a row when the event fires. 
 * All communication is done with the eventBus.
 */
public class SandBox implements EntryPoint {
	
	/* (non-Javadoc)
	 * @see com.google.gwt.core.client.EntryPoint#onModuleLoad()
	 * 
	 * no special code here
	 */
	public void onModuleLoad() {
		// defines the eventBus
		HandlerManager eventBus = new HandlerManager(null);
		
		// create addrow widget and presenter
		AddRowWidget addRowWidget = new AddRowWidget();
		AddRowPresenter addRowPresenter = new AddRowPresenter(addRowWidget, eventBus);
		
		// create specialTablewidget and presenter
		SpecialTableWidget specialTableWidget = new SpecialTableWidget();
		SpecialTablePresenter specialTablePresenter = new SpecialTablePresenter(specialTableWidget, eventBus);
		
		// add both presenters to the eventTestPresenter
		// this is overkill for an application this small
		EventTestPresenter mainPresenter = new EventTestPresenter(addRowPresenter, specialTablePresenter);
		
		// initialize main presenter
		mainPresenter.go(RootPanel.get());
	}
}
