package webspin.projects.sandbox.client;

import webspin.projects.sandbox.client.events.TableRowEvent;
import webspin.projects.sandbox.client.events.TableRowEventHandler;

import com.google.gwt.event.shared.HandlerManager;

class SpecialTablePresenter {
	SpecialTableInterface table;
	HandlerManager eventBus;
	
	/**
	 * Contructor
	 * @param table
	 * @param eventBus
	 */
	public SpecialTablePresenter(SpecialTableInterface table, HandlerManager eventBus)
	{
		this.eventBus = eventBus;
		this.bindWidget(table);
	}
	
	/**
	 * bind the widget to the presenter and the eventbus
	 * @param table2
	 */
	public void bindWidget(SpecialTableInterface table2)
	{
		this.table = table2;
		eventBus.addHandler(TableRowEvent.TYPE, new TableRowEventHandler(){
	        public void onAddRow(TableRowEvent event) {
	            table.addSpecialRow(event.getRowName());
	       	}
	    });
	}
	
	/**
	 * All bound widgets should implement this interface
	 * @author mabogie
	 *
	 */
	interface SpecialTableInterface {
		public void addSpecialRow(String value);
	}
}