package webspin.projects.sandbox.client.events;


import com.google.gwt.event.shared.GwtEvent;

/**
 * Custom event of adding a row to the table
 * 
 * @author Maarten Bogaert
 *
 */
public class TableRowEvent extends GwtEvent<TableRowEventHandler> {

	/**
	 *  For each new event, a new event type must also be specified, 
	 *  with which the event can be registered
	 */
	public static final GwtEvent.Type<TableRowEventHandler> TYPE 
							= new GwtEvent.Type<TableRowEventHandler>();

	private String rowName;
	
	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#dispatch(com.google.gwt.event.shared.EventHandler)
	 */
	@Override
	protected void dispatch(TableRowEventHandler handler) {
		handler.onAddRow(this);
	}

	/* (non-Javadoc)
	 * @see com.google.gwt.event.shared.GwtEvent#getAssociatedType()
	 */
	@Override
	public GwtEvent.Type<TableRowEventHandler> getAssociatedType() {
		return TYPE;
	}

	public void setRowName(String rowName) {
		this.rowName = rowName;
	}

	public String getRowName() {
		return rowName;
	}
}
